; Dunjunz - Games Master Edition
; Copyright (c) 2017-2020 Ciaran Anscomb
;
; See COPYING file for redistribution conditions.

; Bank#0 is selected by default, so BASIC passes control here.
;
; Bank#0 is finished in bank0b.s.

; bank0a is assembled FIRST, to provide dunzip to init and others.

; ========================================================================

                include "dragonhw.s"
                include "defs.s"
                include "macros.s"

; ========================================================================

		org $c000

		jmp INIT_exec

		setdp gamedp

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

; dunzip - unzip simply coded zip data

; 1iiiiiii 0nnnnnnn - repeat 128-n (1-128) bytes from current + 1i (-ve 2s cmpl)
; 1iiiiiii 1jjjjjjj nnnnnnnn - repeat 128-n (1-256) bytes from current + 1ij
; 0nnnnnnn - directly copy next 128-n (1-128) bytes

; Entry:
; 	X -> zipped data
; 	U -> destination
; 	[dzip_end] = end of zipped data

		export dunzip
dunzip
dunz_loop	ldd ,x++
		bpl dunz_run	; run of 1-128 bytes
		tstb
		bpl dunz_7_7
dunz_14_8	lslb		; drop top bit of byte 2
		asra
		rorb		; asrd
		leay d,u
		ldb ,x+
		bra 10F		; copy 1-256 bytes (0 == 256)
dunz_7_7	leay a,u	; copy 1-128 bytes
10		lda ,y+
		sta ,u+
		incb
		bvc 10B		; count UP until B == 128
		bra 30F
20		ldb ,x+
dunz_run	stb ,u+
		inca
		bvc 20B		; count UP until B == 128
30		cmpu <dzip_end
		blo dunz_loop
		rts

; ========================================================================

		export INIT_exec
INIT_exec

; bank0b.s will start here.

