; Dunjunz - Games Master Edition
; Copyright (c) 2017-2020 Ciaran Anscomb
;
; See COPYING file for redistribution conditions.

; ========================================================================



; ========================================================================

		org $c000

		export tiles_pal,tiles_ntsc0,tiles_ntsc1

		include "tiles-pal.s"
		include "lnum-pal.s"
		include "tiles-ntsc0.s"
		include "lnum-ntsc0.s"
		include "tiles-ntsc1.s"
		include "lnum-ntsc1.s"

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

; Sound data

		export snd_tport
		export snd_psh
		export snd_reset_c1
		export snd_reset_c2
		export snd_reset_c3
		export snd_fire
		export snd_magic
		export snd_door
		export snd_monster_hit
		export snd_food
		export snd_low
		export snd_money
		export snd_key
		export snd_exit
		export snd_tport
		export snd_drainer

EDATA		macro
		fcb \1,\2
		endm

snd_reset_c1	fdb snde_none
		fcb $9f
		fcb 0
		fdb sndf_done

snd_reset_c2	fdb snde_none
		fcb $bf
		fcb 0
		fdb sndf_done

snd_reset_c3	fdb snde_none
		fcb $df
		fcb 1,$ff,0
		fdb sndf_done

; A = 15/1, D = 0/0, S = 0, R = 1/4
snd_key		fdb snde_key
		fcb $b0
		fcb 2,$a0,$02
		; fall through to sndf_done
sndf_done	fcb 0
		fdb sndf_done

snde_key	EDATA -1,1
snde_none	EDATA 4,0

; A = 15/1, D = 0/0, S = 27, R = 1/1
snd_monster_hit
		fdb snde_monster_hit
		fcb $f0
		fcb 2,$df,$e5,1
		fcb 1,$ea,1
		fcb 1,$ef,1
		fcb 1,$e4,1
		fcb 1,$e9,1
		fcb 1,$ee,1
		fcb 1,$e3,1
		fcb 1,$e8,1
		fcb 1,$ed,1
		fcb 1,$e2,1
		fcb 1,$e7,1
		fcb 1,$ec,1
		fcb 1,$e1,0
		fdb sndf_done

snde_monster_hit
		EDATA -1,27
		EDATA 20,0

snd_drainer
		fdb snde_drainer
		fcb $f0
		fcb 2,$df,$ec,1
		fcb 1,$e1,1
		fcb 1,$e6,1
		fcb 1,$eb,1
		fcb 1,$e0,1
		fcb 1,$e5,1
		fcb 2,$e2,$e7,1
		fcb 1,$ec,1
		fcb 1,$e1,1
		fcb 1,$e6,1
		fcb 1,$eb,1
		fcb 1,$e0,1
		fcb 1,$e5,1
		fcb 1,$ea,1
		fcb 1,$ef,1
		fcb 1,$e4,1
		fcb 1,$e9,1
		fcb 1,$ee,1
		fcb 1,$e3,1
		fcb 1,$e8,1
		fcb 1,$ed,0
		fdb sndf_done

snde_drainer	EDATA -1,6
		EDATA 0,2
		EDATA 0,27
		EDATA 20,0

snd_low		fdb snde_low
		fcb $ff
		fcb 2,$df,$ea,0
		fdb sndf_done

snde_low	EDATA -20,26
		EDATA 6,0

snd_money	fdb snde_money
		fcb $b0
100		fcb 3,$a7,$03,$a6,2
		fcb 1,$a8,2
		fcb 1,$a7,2
		fcb 1,$a6,0
		fdb 100B

snde_money	EDATA -1,20
		EDATA 8,0

snd_fire
		fdb snde_fire
		fcb $d0
		fcb 2,$cf,$0b,1
		fcb 1,$c2,1
		fcb 3,$ff,$c5,$0a,1
		fcb 2,$ca,$09,1
		fcb 2,$cf,$08,1
		fcb 1,$c5,1
		fcb 2,$cc,$07,1
		fcb 1,$c3,1
		fcb 2,$cb,$06,1
		fcb 1,$c4,1
		fcb 2,$cd,$05,1
		fcb 1,$c6,1
		fcb 1,$c0,0
		fdb sndf_done

snde_fire	EDATA -1,2
		EDATA 20,0

snd_door
		fdb snde_door
		fcb $96
100		fcb 2,$87,$08,1
		fcb 2,$8c,$09,1
		fcb 2,$84,$0b,1
		fcb 2,$8f,$0c,1
		fcb 2,$8f,$0e,1
		fcb 2,$84,$11,1
		fcb 2,$8f,$13,1
		fcb 2,$81,$17,1
		fcb 2,$89,$1a,0
		fdb 100B

snde_door	EDATA -48,11
		EDATA 14,0

snd_food	fdb snde_food
		fcb $96
100		fcb 2,$83,$04,1
		fcb 1,$8c,1
		fcb 2,$88,$05,1
		fcb 2,$86,$06,1
		fcb 2,$85,$07,1
		fcb 2,$87,$08,1
		fcb 2,$8c,$09,1
		fcb 2,$84,$0b,1
		fcb 2,$8f,$0c,0
		fdb 100B

snde_food	EDATA -48,10
		EDATA 14,0

snd_magic	fdb snde_magic
		fcb $b0
100		fcb 2,$af,$28,1
		fcb 2,$a6,$23,1
		fcb 2,$ab,$1e,1
		fcb 2,$a8,$1a,1
		fcb 2,$a6,$23,1
		fcb 2,$a4,$2f,1
		fcb 2,$a1,$3f,1
		fcb 2,$ab,$36,1
		fcb 2,$a4,$2f,0
		fdb 100B

snde_magic	EDATA -1,13
		EDATA 2,0

; the single longest sound effect...
snd_exit	fdb snde_exit
		fcb $b0
		fcb 2,$ad,$01,2
		fcb 1,$ae,2
		fcb 1,$af,2
		fcb 2,$a0,$02,2
		fcb 1,$a1,2
		fcb 1,$a2,2
		fcb 1,$a4,2
		fcb 1,$a5,2
		fcb 1,$a6,2
		fcb 1,$a7,2
		fcb 1,$a8,2
		fcb 1,$a9,2
		fcb 1,$ab,2
		fcb 1,$ac,2
		fcb 1,$ad,2
		fcb 1,$ae,2
		fcb 2,$a0,$03,2
		fcb 1,$a1,2
		fcb 1,$a3,2
		fcb 1,$a4,2
		fcb 1,$a5,2
		fcb 1,$a7,2
		fcb 1,$a9,2
		fcb 1,$aa,2
		fcb 1,$ac,2
		fcb 1,$ae,2
		fcb 2,$a0,$04,2
		fcb 1,$a2,2
		fcb 1,$a3,2
		fcb 1,$a5,2
		fcb 1,$a7,2
		fcb 1,$a9,2
		fcb 1,$ab,2
		fcb 1,$ae,2
		fcb 2,$a0,$05,2
		fcb 1,$a2,2
		fcb 1,$a5,2
		fcb 1,$a7,2
		fcb 1,$aa,2
		fcb 1,$ac,2
		fcb 1,$af,2
		fcb 2,$a2,$06,2
		fcb 1,$a5,2
		fcb 1,$a7,2
		fcb 1,$aa,2
		fcb 1,$ae,2
		fcb 2,$a1,$07,2
		fcb 1,$a4,2
		fcb 1,$a7,2
		fcb 1,$ab,2
		fcb 1,$af,2
		fcb 2,$a3,$08,2
		fcb 1,$a6,2
		fcb 1,$aa,2
		fcb 1,$ae,2
		fcb 2,$a2,$09,2
		fcb 1,$a6,2
		fcb 1,$ab,2
		fcb 1,$af,2
		fcb 2,$a4,$0a,2
		fcb 1,$a9,2
		fcb 1,$ae,2
		fcb 2,$a3,$0b,2
		fcb 1,$a8,2
		fcb 1,$ad,2
		fcb 2,$a3,$0c,2
		fcb 1,$a9,2
		fcb 1,$ae,2
		fcb 2,$a4,$0d,2
		fcb 1,$ab,2
		fcb 2,$a1,$0e,2
		fcb 1,$a8,2
		fcb 1,$ae,2
		fcb 2,$a6,$0f,2
		fcb 1,$ad,2
		fcb 2,$a5,$10,2
		fcb 1,$ac,2
		fcb 2,$a3,$11,2
		fcb 1,$ab,2
		fcb 2,$a4,$12,2
		fcb 1,$ac,2
		fcb 2,$a5,$13,2
		fcb 1,$ae,2
		fcb 2,$a8,$14,2
		fcb 2,$a1,$15,2
		fcb 1,$ab,2
		fcb 2,$a5,$16,2
		fcb 2,$a0,$17,2
		fcb 1,$aa,2
		fcb 2,$a6,$18,2
		fcb 2,$a1,$19,2
		fcb 1,$ac,2
		fcb 2,$a8,$1a,2
		fcb 2,$a6,$1b,2
		fcb 2,$a2,$1c,2
		fcb 1,$af,2
		fcb 2,$ac,$1d,2
		fcb 2,$ab,$1e,2
		fcb 2,$a9,$1f,2
		fcb 2,$a9,$20,2
		fcb 2,$a7,$21,2
		fcb 2,$a6,$22,2
		fcb 2,$a6,$23,2
		fcb 2,$a8,$24,2
		fcb 2,$a8,$25,2
		fcb 2,$aa,$26,2
		fcb 2,$ac,$27,2
		fcb 2,$af,$28,2
		fcb 2,$a1,$2a,2
		fcb 2,$a5,$2b,2
		fcb 2,$a9,$2c,2
		fcb 2,$a0,$2e,2
		fcb 2,$a4,$2f,2
		fcb 2,$ab,$30,2
		fcb 2,$a1,$32,2
		fcb 2,$a8,$33,2
		fcb 2,$a0,$35,2
		fcb 2,$ab,$36,2
		fcb 2,$a3,$38,0
		fdb sndf_done

snde_exit	EDATA -1,14
		EDATA 1,0

snd_tport	fdb snde_tport
		fcb $9f
100		fcb 2,$84,$0b,1
		fcb 2,$87,$08,1
		fcb 2,$85,$07,1
		fcb 2,$86,$06,1
		fcb 2,$8f,$05,1
		fcb 1,$88,0
		fdb 100B

snde_tport	EDATA -2,166
		EDATA 2,0

snd_psh
		fdb snde_psh
		fcb $ff
100		fcb 2,$df,$e4,2
		fcb 1,$e5,2
		fcb 1,$e6,2
		fcb 1,$e5,0
		fdb 100B

snde_psh	EDATA -8,32
		EDATA 8,0

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

bank2_end

		align $4000,$ff
